<?php

namespace Controller;

use Util\InstanceProvider;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\HTTP\Kernel;
use Teknisa\Libs\Util\OAuthCustom;

Class Api extends Simple {
	/** @var OAuthCustom $oauth */
	private $oauth;
    /** @var Kernel $kernel */
    private $kernel;

    public function __construct(OAuthCustom $oauth, Kernel $kernel) {
 		$this->oauth = $oauth;
        $this->kernel = $kernel;
    }

    public function requestToken(Request $request, Response $response){
        try{
            $httpRequest = $this->kernel->getHttpRequest();
            $clientId = $httpRequest->get('CLIENT_ID');
            $clientSecret = $httpRequest->get('CLIENT_SECRET');
            $token = $this->oauth->grantAccessToken($clientId, $clientSecret, array('sessionId' => InstanceProvider::getSession()->getId()));
            $response->addDataSet(new DataSet('token', array($token)));
        }catch (\Exception $e){
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR));
        }
    }
}