<?php

namespace Service;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\DevOps\Util\Environment;
use Zeedhi\Framework\Events\PreDispatch\Listener;

class RequestListenerOAuth extends Listener {
    /** @var  Environment $environment */
    protected $environment;

    public function __construct(Environment $environment) {
        $this->environment = $environment;
    }

    /**
     * @param Request $request
     * @throws \Exception
     */
    public function preDispatch(Request $request)
    {
        try {
            if(!$this->environment->getCurrentUserId() && strpos($request->getRoutePath(),'/lib_') === false) {
                $this->environment->setCurrentUserId($this->environment->getCurrentUserIdDevOps());
                $this->environment->setOrganizationId($this->environment->getCurrentOrganizationIdDevOps());
            }
        } catch (\Exception $e){
            throw new \Exception($e->getMessage());
        }
    }
} 